%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Node_list = Get_Nodes_From_Elements(Elm_list, Excluded_nodes)

% Существование элементов из списка Elm_list должно проверяться вне данной функции до ее вызова
% Существование узлов из списка Excluded_nodes должно проверяться вне данной функции до ее вызова

global DB_ELEMENTS;
global AT_ELEMENTS;

if (isempty(Elm_list))
    Node_list = [];
    return;
end

if (isempty(DB_ELEMENTS))
    Node_list = [];
    return;
end

Elm_list = unique(Elm_list);
Excluded_nodes = unique(Excluded_nodes);

counter = 0;

for i=1:size(Elm_list,1)
    counter = counter + DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.N_nodes;
end

Node_list = zeros(counter,1);

counter = 0;

for i=1:size(Elm_list,1)
    Node_list(counter + 1 : counter + DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.N_nodes) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes;
    counter = counter + DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.N_nodes;
end

Node_list = unique(Node_list);
Node_list = setdiff(Node_list, Excluded_nodes);

if (isempty(Node_list))
	Node_list = [];
end
